package com.ozs.web.controller.websocket;

import com.alibaba.fastjson2.JSONObject;
import com.ozs.common.core.controller.BaseController;
import com.ozs.common.utils.AppendUtils;
import com.ozs.service.entity.BaseCameraManagement;
import com.ozs.service.entity.vo.MsgAlarmResp;
import com.ozs.service.service.BaseRailwayManagementService;
import com.ozs.service.service.BaseUserService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.*;

/**
 * @Author : sunhh
 * @create 2023/3/13 22:08
 */
@Slf4j
@Controller
@RequestMapping("/sdk")
public class WebSocketConteoller extends BaseController {

    @Autowired
    private WebSocketServer webSocketServer;
    @Autowired
    private BaseUserService baseUserService;
    @Resource
    private BaseRailwayManagementService baseRailwayManagementService;

    @ResponseBody
    @PostMapping("/publish")
    public Map publish(@RequestBody BaseCameraManagement baseCameraManagement) {
        // 获取推送人ID列表
        Set<String> set = baseUserService.getUserIdList(baseCameraManagement.getCreateBy(), baseCameraManagement.getDeptId());
        // List<String> list = new ArrayList<>(set);
        String[] list = set.toArray(new String[set.size()]);
        MsgAlarmResp msgAlarmResp = new MsgAlarmResp();
        String begin = AppendUtils.stringAppend(baseCameraManagement.getBeginMile());
        String end = AppendUtils.stringAppend(baseCameraManagement.getEndMile());
        String endMile = begin + "-" + end;
        msgAlarmResp.setBeginMile(endMile);
        String mile = AppendUtils.stringAppend(baseCameraManagement.getInstallMile());
        msgAlarmResp.setAlarmMile(mile);
        String cameraCode = baseCameraManagement.getCameraCode();
        String cameraName = baseRailwayManagementService.getCameraNameByCameraCode(cameraCode);
        msgAlarmResp.setRailwayName(cameraName);
        // 推送消息reqMsgAlarmVo
        webSocketServer.sendMoreMessage(list, objStr(msgAlarmResp));
        HashMap<String, Object> map = new HashMap<>();
        map.put("code", 200);
        return map;
    }

    private String objStr(MsgAlarmResp msgAlarmResp) {
        JSONObject obj = new JSONObject();
        obj.put("pipelineId", msgAlarmResp); //流水线ID
        log.info("【websocket消息】 单点消息:" + obj.toJSONString());
        return obj.toJSONString();
    }
}
